#pragma once

#include <vector>

class BitStream
{
public:
    bool getNextNBits(unsigned n, unsigned char& buffer);

    bool loadNextByte();

    void setByte(unsigned idx, unsigned char data);

    void setBufferSize(std::size_t size);

    unsigned char getCurrentByte() const
    {
        return mCurrentByte;
    }

private:
    unsigned mByteOffset{0};
    unsigned mBitOffset{0};

    char mCurrentByte{0};
    std::vector<unsigned char> mBuffer;
};
